## ros-galactic-rmw-implementation 2.4.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)

project(rmw_implementation)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

find_package(ament_cmake REQUIRED)
find_package(rmw_implementation_cmake REQUIRED)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

get_default_rmw_implementation(RMW_IMPLEMENTATION)

message(STATUS "")
message(STATUS "Default rmw implementation: '${RMW_IMPLEMENTATION}'")
message(STATUS "")

get_available_rmw_implementations(available_rmw_implementations)
list(LENGTH available_rmw_implementations count_available_rmw_implementations)
if(count_available_rmw_implementations EQUAL 1)
  set(rmw_implementation_disable_runtime_selection_default ON)
else()
  set(rmw_implementation_disable_runtime_selection_default OFF)
endif()

option(RMW_IMPLEMENTATION_DISABLE_RUNTIME_SELECTION "\
  Use only the RMW implementation specified at build time via the \
  'RMW_IMPLEMENTATION' environment variable and the 'RMW_IMPLEMENTATION' \
  CMake option, ignoring the runtime value of the 'RMW_IMPLEMENTATION' \
  environment variable"
  ${rmw_implementation_disable_runtime_selection_default})

if(RMW_IMPLEMENTATION_DISABLE_RUNTIME_SELECTION)
  message(STATUS "Runtime selection of RMW disabled; Only using "
    "'${RMW_IMPLEMENTATION}'")
else()
  message(STATUS "Runtime selection of RMW enabled")

  find_package(rcpputils REQUIRED)
  find_package(rcutils REQUIRED)
  find_package(rmw REQUIRED)

  add_library(${PROJECT_NAME} SHARED
    src/functions.cpp)
  ament_target_dependencies(${PROJECT_NAME}
    "rcpputils"
    "rcutils"
    "rmw")
  target_compile_definitions(${PROJECT_NAME}
    PUBLIC "DEFAULT_RMW_IMPLEMENTATION=${RMW_IMPLEMENTATION}")

  # Causes the visibility macros to use dllexport rather than dllimport,
  # which is appropriate when building the dll but not consuming it.
  target_compile_definitions(${PROJECT_NAME} PRIVATE "RMW_IMPLEMENTATION_BUILDING_DLL")

  if(BUILD_TESTING)
    # Causes symbols to be exposed for tests to use.
    target_compile_definitions(${PROJECT_NAME} PRIVATE
      "RMW_IMPLEMENTATION_DEFAULT_VISIBILITY=RMW_IMPLEMENTATION_PUBLIC")
  endif()

  configure_rmw_library(${PROJECT_NAME})

  ament_export_libraries(${PROJECT_NAME})
  ament_export_targets(${PROJECT_NAME})
  ament_export_dependencies(rcpputils rcutils)

  if(BUILD_TESTING)
    find_package(ament_cmake_gtest REQUIRED)
    ament_add_gtest(test_functions test/test_functions.cpp)
    ament_target_dependencies(test_functions rcutils rmw)
    target_link_libraries(test_functions ${PROJECT_NAME})

    find_package(performance_test_fixture REQUIRED)
    # Give cppcheck hints about macro definitions coming from outside this package
    get_target_property(ament_cmake_cppcheck_ADDITIONAL_INCLUDE_DIRS performance_test_fixture::performance_test_fixture
      INTERFACE_INCLUDE_DIRECTORIES)

    macro(benchmark_rmws)
      find_package(${rmw_implementation} REQUIRED)
      message(STATUS "Creating API tests for '${rmw_implementation}'")
      set(rmw_implementation_env_var RMW_IMPLEMENTATION=${rmw_implementation})

      add_performance_test(benchmark_symbols${target_suffix} test/benchmark/benchmark_symbols.cpp
        ENV ${rmw_implementation_env_var})
      if(TARGET benchmark_symbols${target_suffix})
        target_link_libraries(benchmark_symbols${target_suffix} ${PROJECT_NAME})
      endif()
    endmacro()
    call_for_each_rmw_implementation(benchmark_rmws)
  endif()

  install(
    TARGETS ${PROJECT_NAME} EXPORT ${PROJECT_NAME}
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
  )
endif()

register_rmw_implementation(
  "c:rosidl_typesupport_c"
  "cpp:rosidl_typesupport_cpp"
)

ament_package(
  CONFIG_EXTRAS "rmw_implementation-extras.cmake.in"
)

=== debian/changelog ===
ros-galactic-rmw-implementation (2.4.1-3focal) focal; urgency=high



 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Fri, 16 Apr 2021 07:00:00 -0000

ros-galactic-rmw-implementation (2.4.0-3focal) focal; urgency=high

  * Unique network flows (#170 <https://github.com/ros2/rmw_implementation/issues/170>)
  * updating quality declaration links (re: ros2/docs.ros2.org#52 <https://github.com/ros2/docs.ros2.org/issues/52>) (#185 <https://github.com/ros2/rmw_implementation/issues/185>)
  * Contributors: Ananya Muddukrishna, shonigmann

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Tue, 06 Apr 2021 07:00:00 -0000

ros-galactic-rmw-implementation (2.3.0-3focal) focal; urgency=high

  * Remove rmw_connext_cpp. (#183 <https://github.com/ros2/rmw_implementation/issues/183>)
  * Add support for rmw_connextdds (#182 <https://github.com/ros2/rmw_implementation/issues/182>)
  * Contributors: Andrea Sorbini, Chris Lalancette

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Thu, 25 Mar 2021 07:00:00 -0000

ros-galactic-rmw-implementation (2.2.0-3focal) focal; urgency=high

  * Add function for checking QoS profile compatibility (#180 <https://github.com/ros2/rmw_implementation/issues/180>)
  * Shorten some excessively long lines of CMake (#179 <https://github.com/ros2/rmw_implementation/issues/179>)
  * Add rmw_fastrtps_dynamic_cpp to the explicit group deps (#177 <https://github.com/ros2/rmw_implementation/issues/177>)
  * Contributors: Jacob Perron, Scott K Logan

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Mon, 08 Mar 2021 08:00:00 -0000

ros-galactic-rmw-implementation (2.1.2-3focal) focal; urgency=high

  * Accept any RMW implementation, not just the default (#172 <https://github.com/ros2/rmw_implementation/issues/172>)
  * Contributors: Scott K Logan

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Fri, 29 Jan 2021 08:00:00 -0000

ros-galactic-rmw-implementation (2.1.1-3focal) focal; urgency=high

  * Defer path resolution of rmw implementation libraries to dynamic linker. (#169 <https://github.com/ros2/rmw_implementation/issues/169>)
  * Contributors: Michel Hidalgo

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Mon, 25 Jan 2021 08:00:00 -0000

ros-galactic-rmw-implementation (2.1.0-3focal) focal; urgency=high

  * Update QD to QL 1 (#166 <https://github.com/ros2/rmw_implementation/issues/166>)
  * Fix up C functions to never throw. (#149 <https://github.com/ros2/rmw_implementation/issues/149>)
  * Restored Dirk as author (#155 <https://github.com/ros2/rmw_implementation/issues/155>)
  * Update maintainers (#154 <https://github.com/ros2/rmw_implementation/issues/154>)
  * Updated performance QD section (#153 <https://github.com/ros2/rmw_implementation/issues/153>)
  * Update Quality Declaration to QL2. (#151 <https://github.com/ros2/rmw_implementation/issues/151>)
  * Add nominal test for symbol prefetch() and unload. (#145 <https://github.com/ros2/rmw_implementation/issues/145>)
  * Added benchmark test to rmw_implementation (#127 <https://github.com/ros2/rmw_implementation/issues/127>)
  * Test load and lookup functionality. (#135 <https://github.com/ros2/rmw_implementation/issues/135>)
  * Contributors: Alejandro Hernández Cordero, Michel Hidalgo, Stephen Brawner

 -- Alejandro Hernandez Cordero <alejandro@openrobotics.org>  Thu, 10 Dec 2020 08:00:00 -0000

ros-galactic-rmw-implementation (2.0.0-3focal) focal; urgency=high

  * Remove domain_id and localhost_only from node API (#114 <https://github.com/ros2/rmw_implementation/issues/114>)
  * Move the quality declaration into the rmw_implementation subdirectory. (#111 <https://github.com/ros2/rmw_implementation/issues/111>)
  * Contributors: Chris Lalancette, Ivan Santiago Paunovic

 -- Dirk Thomas <dthomas@osrfoundation.org>  Wed, 08 Jul 2020 07:00:00 -0000

ros-galactic-rmw-implementation (1.0.0-3focal) focal; urgency=high

  * Remove MANUAL_BY_NODE liveliness API (#101 <https://github.com/ros2/rmw_implementation/issues/101>)
  * Contributors: Ivan Santiago Paunovic

 -- Dirk Thomas <dthomas@osrfoundation.org>  Tue, 12 May 2020 07:00:00 -0000

ros-galactic-rmw-implementation (0.9.0-3focal) focal; urgency=high

  * Rename rosidl_message_bounds_t (#98 <https://github.com/ros2/rmw_implementation/issues/98>)
  * Adapt interfaces for service timestamps (#96 <https://github.com/ros2/rmw_implementation/issues/96>)
  * Add take_sequence to RMW API (#93 <https://github.com/ros2/rmw_implementation/issues/93>)
  * Export targets in addition to include directories / libraries (#97 <https://github.com/ros2/rmw_implementation/issues/97>)
  * Removed ament_cmake_python from package.xml (#95 <https://github.com/ros2/rmw_implementation/issues/95>)
  * Using get_env_var from rcpputils (#94 <https://github.com/ros2/rmw_implementation/issues/94>)
  * security-context -> enclave (#91 <https://github.com/ros2/rmw_implementation/issues/91>)
  * Fix dependency on rmw_implementation_cmake (#92 <https://github.com/ros2/rmw_implementation/issues/92>)
  * Removed poco dependency (#87 <https://github.com/ros2/rmw_implementation/issues/87>)
  * Use one participant per context API changes (#77 <https://github.com/ros2/rmw_implementation/issues/77>)
  * Add rmw_*_event_init() functions to rmw_implementation (#88 <https://github.com/ros2/rmw_implementation/issues/88>)
  * Moved rmw_implementation_cmake from depend to build_depend (#82 <https://github.com/ros2/rmw_implementation/issues/82>)
  * Removed python code (#85 <https://github.com/ros2/rmw_implementation/issues/85>)
  * Remove OpenSplice dependency (#79 <https://github.com/ros2/rmw_implementation/issues/79>)
  * Code style only: wrap after open parenthesis if not in one line (#78 <https://github.com/ros2/rmw_implementation/issues/78>)
  * Depend on rcpputils for find_library (#57 <https://github.com/ros2/rmw_implementation/issues/57>)


=== debian/control ===
Source: ros-galactic-rmw-implementation
Section: misc
Priority: optional
Maintainer: Alejandro Hernandez Cordero <alejandro@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-galactic-ament-cmake, ros-galactic-ament-cmake-gtest, ros-galactic-ament-lint-auto, ros-galactic-ament-lint-common, ros-galactic-performance-test-fixture, ros-galactic-rcpputils, ros-galactic-rcutils, ros-galactic-rmw, ros-galactic-rmw-connextdds, ros-galactic-rmw-cyclonedds-cpp, ros-galactic-rmw-fastrtps-cpp, ros-galactic-rmw-fastrtps-dynamic-cpp, ros-galactic-rmw-implementation-cmake, ros-galactic-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-galactic-rmw-implementation
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-galactic-rcpputils, ros-galactic-rcutils, ros-galactic-rmw-implementation-cmake, ros-galactic-ros-workspace, ros-galactic-rmw-cyclonedds-cpp | ros-galactic-rmw-connextdds | ros-galactic-rmw-fastrtps-cpp
Description: The decision which ROS middleware implementation should be used for C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/galactic/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/galactic" \
		-DAMENT_PREFIX_PATH="/opt/ros/galactic" \
		-DCMAKE_PREFIX_PATH="/opt/ros/galactic"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-galactic-rmw-implementation//opt/ros/galactic/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/galactic/setup.sh" ]; then . "/opt/ros/galactic/setup.sh"; fi && \
	dh_auto_install
